################  DESCRIPTOR COMPUTATION VARIABLES  ################
DESCRIPTOR_FORCE_ANALYSIS = False
# ircamdescriptor binary
DESCRIPTOR_WIN_SIZE_SEC = 0.12
DESCRIPTOR_HOP_SIZE_SEC = 0.02
DESCRIPTOR_RESAMPLE_RATE = 12500 # ircam's default value (still tho?)
DESCRIPTOR_WINDOW_TYPE = 'blackman'
DESCRIPTOR_NUMB_BANDS = 23 # mfcc, roughness, perceptual, etc.
DESCRIPTOR_F0_MAX_ANALYSIS_FREQ = 3000
DESCRIPTOR_F0_MIN_FREQUENCY = 200
DESCRIPTOR_F0_MAX_FREQUENCY = 1000
DESCRIPTOR_F0_AMP_THRESHOLD = 30
DESCRIPTOR_F0_QUALITY = 0.2
# supervp
DESCRIPTOR_NUMB_PEAKS = 12 
# clustering
DESCRIPTOR_CLUSTS_DESCRIPTOR_DIM = {'mfcc1': 1, 'mfcc2': 1, 'mfcc3': 1, 'mfcc4': 1, 'mfcc5': 1}
# must be time varying
# must not be packaged
DESCRIPTOR_NUMB_CLUSTS = 8 

#############  MISC  #############
RANDOM_SEED = None # None==use timestamp
VERBOSITY = 2
USE_PROGRESS_BAR = True
PRINT_LENGTH = 90
ALERT_ON_ERROR = True # sound the system alert when exiting with an error
LOAD_ADDITIONAL_DESCRIPTORS = []
SEARCH_CORPUS_PARAM_INTERPOLATE = False # experimental
SEARCH_CORPUS_PARAM_INTERPOLATE_POINTS = 5
PARAMETER_PACKAGE = None # may be a file or a list of files
OUTPUT_LOG_FILE = 'output/log.txt'
OUTPUT_DATA_JSON_FILE = 'output/audioguide-data.json.txt' # for different types of internally computed analyses
ORDER_CORPUS_BY_DESCRIPTOR = []



#############  INFO PRINT  #############
PRINT_CORPUS_INFO = True
PRINT_NORM_INFO = False
PRINT_SELECTION_HISTO = False
PRINT_SIM_SELECTION_HISTO = True
PRINT_ELAPSED_TIMES = False



#############  SEARCH PATHS  #############
TARGET_PATH = 'target/' # look here for targets.. abs path or relative path to the audioguide directory
SOURCE_PATH = 'source/' # look here for database soundfiles.. abs path or relative path to the audioguide directory
OPTIONS_DIR = 'options/' # look here for options files.. abs path or relative path to the audioguide directory
PACKAGES_PATH = 'packages/' # look here for parameter packages.. abs path or relative path to the audioguide directory
TMP_PATH = '/tmp' # put tmp data here

###############  OUTPUT PATHS  ################
CSOUND_MAKE_SCORE = True
CSOUND_SCORE_PATH = 'output/csoundScore.txt'
CSOUND_WRITE_SCORE_COMMENTS = False
CSOUND_RENDER_SCORE = True
CSOUND_RENDER_WITH_ULIMIT= True
CSOUND_PLAY_RENDERED_FILE = True
CSOUND_RENDER_SEPARATE_FILE_FOR_EACH_CORPUS_ENTRY = False
CSOUND_RENDER_SEPARATE_FILE_FOR_EACH_CORPUS_OVERLAP = False

MAKE_QLIST = False
OUTPUT_QLIST_NAME = 'output/qlistScore.txt'
MAKE_LISP_EVENT_LIST = False
LISP_EVENT_LIST_NAME = 'output/events.lisp'
MAKE_OPEN_MUSIC_SCORE = False
OM_SCORE_NAME = 'output/openMusicScore.txt'
TGT_OM_SCORE_NAME = 'output/tgtOmScore.txt'
MAKE_MIDIFILE = True
MIDI_FILE_NAME = 'output/midiFile.mid'
MAKE_ENP_SCORE = False
ENP_SCORE_NAME = 'output/enpScore.lisp'
MAKE_BACH_SCORE = False
BACH_SCORE_NAME = 'output/bachCommands.txt'
SAVE_OUTPUT_SEGMENT_LABELS = True
OUTPUT_SEGMENT_LABELS = 'output/outputLabels.txt'
SAVE_TARGET_SEGMENT_LABELS = True
TARGET_SEGMENT_LABELS = 'output/tgtLabels.txt'
TARGET_SEGMENT_MULTI_LABELS = 'output/tgtLabelsMulti.txt'
SAVE_CONFIG_FILE = True
CONFIG_FILE_NAME = 'output/parsedOptions.py'
SAVE_TARGET_SEGMENT_OR_LINK = False
TARGET_SEGMENT_OR_LINK = 'output/target.aiff'
CSOUND_OUTPUT_FILE = 'output/output.aiff'
MAKE_OUTPUT_MIX = False
CSOUND_OUTPUT_MIX_FILE = 'output/outputMix.aiff'
MAKE_SEGMENTED_TARGET_SF = False
CSOUND_SEGMENTED_TARGET_SF = 'output/segmentedTarget.aiff'
CSOUND_OUTPUT_MIX_PAN = 'middle' # 'middle' || 'leftRight'
OUTPUT_FLOAT_PRECISION = 3
MAKE_PARAM_SCORE = False
PARAM_SCORE_FILE = 'output/paramscore.txt'


############ TARGET  ############
TARGET_SCALE_DB = 0
MODIFY_TARGET_AMP = None # e.g. ('**', 2), ('/', 0.5), etc.
TARGET_DESCRIPTORS_MOD = []
#TARGET_DESCRIPTORS_BASH = []
TARGET_PLOT_METRICS = False


############ TARGET SEGMENTATION ############
TARGET_ONSET_THRESHOLD = -20
TARGET_ONSET_DESCRIPTORS = {'power-odf-7': 1}
TARGET_ONSET_FORCE_MAX = {}
TARGET_ONSET_THRESHOLD_SIM_PENALITY = +0
TARGET_ONSET_THRESHOLD_ACTIVE_PENALITY = +0
TARGET_OFFSET_RISE_RATIO = 1.3
TARGET_SEGMENT_DROP_RATIO = 12.0
TARGET_INCREMENT = 'frame'
TARGET_OFFSET_DB_ABOVE_MIN = 12 # this many dB above the minimum power causes an offset
TARGET_SEGMENT_LENGTH_DROP_METHOD = 'absDb' # always absDb!
TARGET_ONSET_ENVELOPE = 'raw' # orig=unsubtracted, raw=subtracted
TARGET_OFFSET_ENVELOPE = 'raw' # orig=unsubtracted, raw=subtracted
TARGET_MIN_SEGMENT_LENGTH = 0.05
TARGET_MAX_SEGMENT_LENGTH = 4
TARGET_INCREMENT_ENVELOPE = 'raw' # orig=unsubtracted, raw=subtracted
TARGET_MIN_INCREMENT = 1
TARGET_LOAD_SEGMENTS_FROM_FILE = False
# impose a grid shape to the target's power
# None = do nothing
# else: a dict:
#  {'period': 0.125, 'duration': 0.1, 'slope': 2, 'norm': True, 'randomnessSec': 0.05}
# takes place before ag.loadAnalsOnFly
TARGET_MAKE_GRID_ATTENUATION = None 

###############  CORPUS RESTRICTION   #############
CORPUS_GLOBAL_ATTRIBUTE_DEFAULTS = {'wholeFile': False, 'recursive': True, 'scaleDb': 0, 'restrictOverlaps': None, 'restrictInTime': 0, 'segmentationExtension': '.txt', 'limit': {}, 'minTime': 0, 'maxTime': 21474836, 'onsetLen': 0.01, 'offsetLen': 30, 'simSelectRule': None, 'MIDIPitch': 'filename', 'MWinstrName': ''} # dont change me!
CORPUS_GLOBAL_ATTRIBUTES = {} # takes scaleDb, limit, minTime, maxTime, restrictInTime, includeString, excludeString
MW_DEFINE_INSTRUMENTS = []
LIMIT_CORPUS_BY_DESCRIPTOR = {}
CAN_USE_SAME_SEGMENT_TWICE = True
CAN_REUSE_SEGMENT_AFTER = 0
VOICE_PATTERN = []
VOICE_WEIGHT = {}
CORPUS_RESTRICT_DISCRIPTOR_IN_TIME = []
CORPUS_RESTRICT_NUMBER_STREAMS = 0
MAX_ACTIVE_VOICES = None
ROTATE_VOICES = False
SOUNDFILE_EXTENSIONS = ['.aiff', '.aif', '.wav', '.au'] # load dir -> skip files without these extensions; case insensative
SPECTRAL_POWER_THRESHOLD = 0.5 # for effDur-seg on database segments
LIMIT_SEGMENT_DURATIONS = None
CORPUS_POCKETING = False
CORPUS_POCKETING_ROTATE = False
CORPUS_POCKET_SEGMENT_RANDOM_RANGE = [1, 4]

##############  DATA NORMALIZATION   #############
NORMALIZE_METHOD = 'stddev'
NORMALIZE_DEFAULT_METHOD = 2
NORMALIZE_TARGET_SEGMENTS_ONLY = True # generally a good idea
NORMALIZE_SCALE_STD_DEV = 1
NORMALIZE_NUMBER_CLUSTERS = 6
NORMALIZE_CLUSTER_MAPPING = 'leastSqrError'
NORMALIZE_CLUSTERS_METHOD = 'stddev' # 'stddev' || 'minmax'

######  CONCATENATE SELECTION  #######

# NEW NAMES
SIMILARITY_DESCRIPTOR_SEARCH_RESULT_TYPE = 'closest' # closest || farthest || closest_percentage || farthest_percentage
SIMILARITY_DESCRIPTOR_PERCENTAGE = None
SIMILARITY_FIRST_PASS_SEARCH_RESULT_TYPE = 'closest_percentage' # closest || farthest || closest_percentage || farthest_percentage
SIMILARITY_FIRST_PASS_PERCENTAGE = 30 # int || None
SIMILARITY_ARRAY_DISTANCE_DEFAULT = 'euclidean'
#SIMILARITY_WEIGHT_DISTANCE_WITH_ENVELOPE = False
#SIMILARITY_WEIGHT_DISTANCE_WITH_CORPUS_AMP = False





MATCH_SEARCH_METHOD = 'power' # 'time' || 'power'
#MATCH = 'best'
#MATCH_PERCENT = 0
MATCH_DISTANCE_DEFAULT = 'euclidean'
MATCH_WEIGHT_DISTANCE_WITH_ENVELOPE = False
MATCH_WEIGHT_DISTANCE_WITH_CORPUS_AMP = False

FIRST_PASS_DESCRIPTORS = {}
FIRST_PASS_PERCENT = 100
FILTER_CORPUS_BY_DESCRIPTOR_TOLERENCE = {}
SIM_CALC_PEAK_ALIGN = 'none' # none || align
SIM_CALC_LENGTH = 'sourceEffDur' # least || most || sourceEffDur ||  targetEffDur || sourceLength
CONCATENATE_PEAK_ALIGN = 'none' # align || align
CONCATENATE_PEAK_ALIGN_ENVELOPE = 'raw' # orig=unsubtracted, raw=subtracted
VOICE_RESTRICT_PER_SEGMENT = False
PLOT_MATCHES = False # NOT USABLE WITHOUT PYPLOT
LESSEN_PENALTY_FOR_SHORT_EFFDURS = 1 # amount to scale simcalc for shorter effdurs -- in 
ALIGN_NOTE_PEAKS = False
CSOUND_SCORE_DURATION_TYPE = 'corpusDur' # corpusDur || corpusEffDur || targetDur || simCalcDur
MATCH_PEAKS = False # a peak matching algorithm unique for peakFreqs-N
MATCH_PEAKS_AMP_THRESH = 0.1
MATCH_PEAKS_TRANS_UP_AND_DOWN = 6. # in semitones
MATCH_PEAKS_TRANS_ITERATE_INTERVAL = 1 # what interval to search by...
MATCH_PEAKS_CHROMA_ONLY = True
MATCH_PEAKS_USE_PARTIAL_AMPLITUDE = True
ALWAYS_MAKE_COMPLETE_MATCHING_RESULTS = False

#####  CONCATENATE SIMULTANEOUS SELECTION  ######
MIN_SEGMENTS_PER_ONSET = 1
MAX_SEGMENTS_PER_ONSET = 8
MIN_SIMULTANEOUS_SEGMENTS = None
MAX_SIMULTANEOUS_SEGMENTS = None
SIMULTANEOUS_SELECTION_METHOD = "mixture" # None/"none"/"None" || "mixture"
SCALE_POWER_SUBTRACTION = 1
SCALE_POWER_SUBTRACTION_WITH_SEGMENTS_ENVELOPE = True
CORPUS_SUBTRACT_DURATION = 'corpusDur' # corpusDur || corpusEffDur || targetDur || simCalcDur || minDur
CORPUS_AMPLITUDE_DURATION = 'corpusDur' # corpusDur || corpusEffDur || targetDur || simCalcDur || minDur
CORPUS_OVERLAP_DURATION = 'corpusEffDur' # corpusDur || corpusEffDur || targetDur || simCalcDur || minDur
RANDOMIZE_AMPLITUDE_FOR_SIM_SELECTION = False

################  CONCATENATE AMPLITUDE   ################
OUTPUT_GAIN = 0
POST_SELECTION_AMP_SCALE = "None" # "None" || "lstSqr" || "peakAmp"
POST_SELECTION_AMP_MIN = -12 # only if POST_SELECTION_AMP_SCALE != None
POST_SELECTION_AMP_MAX = +12
POST_SELECTION_AMP_PEAK_AMP_METRIC = 'power-seg'

################  CONCATENATE TIME MANIPULATION  ################
TEMPO_CHANGE = 60
RHYTHM_QUANTIZE = 0
RHYTHM_QUANTIZE_METHOD = 'aggregate'
BACH_TEMPO = 60
BACH_METER = '4/4'
STRETCH_NOTE_DURATIONS_TO_MATCH_TARGET = False

############  CONCATENATE TRANSPOSITION  ###########
RANDOM_TRANSPOSE = None
TRANSPOSE_TO_FIT_TARGET_SEGMENT_LENGTH = False
SMART_TRANSPOSE = False
TRANSPOSE_QUANTIZE = 0
