import sys, os 
import utilities

class pathRetriever:
	def __init__(self, AudioGuidePath, ScriptPath, loadOptionsFromFile, optionsPath=None): # was hard coded optionsPath
		self.audioGuidePath = AudioGuidePath
		self.scriptPath = ScriptPath
		self.loadOptionsFromFile = loadOptionsFromFile
		self.optionsPath = optionsPath # folder of the options file
		if self.optionsPath == None: self.optionsPath = self.scriptPath
	############################################################################
	def test(self, file, relativePath): 
		# returns (exists bool, absolute path of a file, file type) -- does NOT die if not found!
		exists = False
		fileType = None
		possibilities = [os.path.normpath(file), os.path.normpath(os.path.join(relativePath, file)), os.path.normpath(os.path.join(self.scriptPath,relativePath,file)), os.path.normpath(os.path.join(self.optionsPath, file))]
		if self.loadOptionsFromFile != None: possibilities.append(os.path.normpath(os.path.join(os.path.split(self.loadOptionsFromFile)[0], file)))
		for path in possibilities: # had os.path.normpath(os.path.join(os.path.split(self.optionsPath)[0], file))
			if os.path.exists(path):
				exists = True
				if os.path.isdir(path): fileType = 'dir'
				if os.path.isfile(path): fileType = 'file'
				if os.path.islink(path): fileType = 'link'
				break
		return exists, path, fileType
	############################################################################
	def testAndDie(self, file, relativePath): 
		exists = False
		possibilities = [os.path.normpath(file), os.path.normpath(os.path.join(relativePath, file)), os.path.normpath(os.path.join(self.scriptPath,relativePath,file)), os.path.normpath(os.path.join(self.optionsPath, file))]
		if self.loadOptionsFromFile != None: possibilities.append(os.path.normpath(os.path.join(os.path.split(self.loadOptionsFromFile)[0], file)))

		for path in possibilities: # had  os.path.normpath(os.path.join(os.path.split(self.optionsPath)[0], file))
			if os.path.exists(path):
				exists = True
				break
		if not exists: self.die(file)
	############################################################################
	def locate(self, *components): # joins path elements and see if its a relative path -- dies if not found!
		if os.path.isabs(components[-1]):
			return components[-1] # if user supplied var is a valid path, use it
		else:
			relativePath = os.path.join(self.scriptPath, *components)
			if not os.path.isabs(relativePath): self.die(relativePath, components[-1])
			return relativePath # otherwise make into a relative path...
	############################################################################
	def die(self, paths):
		print "\n\nFATAL ERROR!\t",str(paths), "not found!\n"
		utilities.exit(1)
	############################################################################
	def checkDirsExist(self, ops):
		if not os.path.exists(self.locate(ops.TMP_PATH)):
			os.makedirs(self.locate(ops.TMP_PATH))
