#!/Library/Frameworks/Python.framework/Versions/Current/bin/python
import sys, os, numpy
import audioguide
def getFeatureDistance(anal, WEIGHT_ENERGY, handle1, st1, ed1, handle2, st2, ed2):
	if audioguide.analMetrics.metric[anal]['segmented'] == False:
		targetArray = numpy.array(handle1.data['norm'][anal][st1:ed1])
		sourceArray = numpy.array(handle2.data['norm'][anal][st2:ed2])
		if WEIGHT_ENERGY:
			distance = audioguide.comp.numpyEuclidDist(audioguide.energyWeight(targetArray, handle1.data['raw']['power'][st1:ed1]), audioguide.energyWeight(sourceArray, handle2.data['raw']['power'][st2:ed2]))
		else:
			distance = audioguide.comp.numpyEuclidDist(targetArray, sourceArray)
	else:
		sourceVal = handle2.data['norm'][anal][0] # seg data
		targetVal = handle1.onFlySegmentCalc(anal, st, ed) # seg data
		distance = (targetVal-sourceVal)**2 # a euclidean quickie
	return distance

LOCAL_PATH = '/Users/ben/Documents/audioGuide/dissim/caged/'
WHICH_SET = 1
SOUND_DIR = 'sound.'+str(WHICH_SET)+'/'
TARGET_FILE = 'tgt.'+str(WHICH_SET)+'.aiff'
OUTPUT_DIR = LOCAL_PATH+'catart.'+str(WHICH_SET)+'/'
print "SOUND DIRECTORY ->", SOUND_DIR
print "TARGET ->", TARGET_FILE
print "OUTPUT DIRECTORY ->", OUTPUT_DIR
if os.path.exists(OUTPUT_DIR) == False: os.makedirs(OUTPUT_DIR)
if LOCAL_PATH.split('/')[-1] == "": DATA_NAME = LOCAL_PATH.split('/')[-2]
else: DATA_NAME = LOCAL_PATH.split('/')[-1]

ag = audioguide.main('/Users/ben/Documents/audioGuide', '/Users/ben/Documents/audioGuide/options/options.py')
# set ops here....
audioguide.ops.TARGET = [LOCAL_PATH+TARGET_FILE, 0, None]
audioguide.ops.SOURCE_NAMES = ['/dissim/caged/'+SOUND_DIR]
audioguide.ops.SOURCE_PATH = LOCAL_PATH+SOUND_DIR
audioguide.ops.USE_DATABASE = False
audioguide.ops.RANDOM_TRANSPOSE = None
audioguide.ops.WEIGHT_DISTANCE_WITH_ENERGY = True
audioguide.ops.FIRST_PASS_METRICS = {}
audioguide.ops.DISTANCE_METRICS = {'centroid': 1, 'power': 1}
audioguide.ops.NORMALIZE_METHOD = 'minmax'
audioguide.ops.NORMALIZE_TARGET_SEPERATELY = False

output = {}
bestTgt = []

# load data, analyse...
ag.init()
ag.loadTarget()
ag.loadDatabase()
ag.normalizeData()

# measure similary from target to each source...
execfile(LOCAL_PATH+'runConfig.txt') # loads configList into memory
metricsUsed = []
weightsUsed = []
for i in configList[0]: # get metric names
	metricsUsed.append( i[1] )
for c in configList: # get metric weights for each run indexed...
	tmp = []
	for i in c:
		tmp.append( i[0] )
	weightsUsed.append(tmp)

for h in audioguide.ag.sourceHandles:
	# get this run's configuration
	runNumber = int(h.name.split('.')[0])
	thisWeightList = weightsUsed[runNumber]
	print runNumber, thisWeightList
#	configFile = LOCAL_PATH+'config/'+str(runNumber*2)+'.txt'# times two to skip other configs from first pass
#	tmp = {}
#	execfile(configFile, tmp)
#	thisWeightList = []
#	for i in metricsUsed:
#		if tmp['DISTANCE_METRICS'].has_key(i): thisWeightList.append(tmp['DISTANCE_METRICS'][i])
#		else: thisWeightList.append(0.0)

	targetSourceDistance = 0
	for anal in audioguide.analMetrics.distance:
		if anal == 'power': energyWeight = False
		else: energyWeight = True
		targetSourceDistance += getFeatureDistance(anal, energyWeight, audioguide.tgt, 0, audioguide.tgt.lengthInFrames, h, 0, audioguide.tgt.lengthInFrames)
	print audioguide.tgt.name, "->", h.name, '=', targetSourceDistance
	output[runNumber] = {'handle': h, 'weights': thisWeightList, 'tgtDist': targetSourceDistance}


# measure similary from source to source...
for run in output:
	whichCalcs = range(run+1, len(audioguide.ag.sourceHandles)) # how many others to measure to, starting with run+1
	outCalcs = [0.0]*(len(audioguide.ag.sourceHandles)*2) # length of the total number of runs*2, filled with zeros
	for calcIdx in whichCalcs:
		src1 = output[run]['handle']
		src2 = output[calcIdx]['handle']
		sourceSourceDistance = 0
		for anal in audioguide.analMetrics.distance:
			if anal == 'power': energyWeight = False
			else: energyWeight = True
			sourceSourceDistance += getFeatureDistance(anal, energyWeight, src1, 0, audioguide.tgt.lengthInFrames, src2, 0, audioguide.tgt.lengthInFrames)
		#print src1.name, '->', src2.name, '=', sourceSourceDistance
		#print "write idx:", run, "write pos:", calcIdx
		outCalcs[calcIdx*2] = sourceSourceDistance
	output[run]['avg'] = [output[run]['tgtDist'], output[run]['tgtDist'], output[run]['tgtDist'], 0] # davg, dmin, dmax, dstddev
	bestTgt.append((output[run]['tgtDist'], run))
	output[run]['avg'].extend(outCalcs)



writeLine = ['']*len(output)
for out in output:
	for i in range(len(output[out]['weights'])): output[out]['weights'][i] = str(output[out]['weights'][i])
	for i in range(len(output[out]['avg'])): output[out]['avg'][i] = str(output[out]['avg'][i])
	writeLine[out] = ' '.join(audioguide.chain([output[out]['weights'], output[out]['avg']]))


# write data file
outputFile = open(OUTPUT_DIR+'/'+DATA_NAME+'.data.txt', 'w')
for i in range(len(writeLine)):
	outputFile.write( writeLine[i]+'\n')
outputFile.close()




# add target to output for writting catart files
print "TARGET", len(output)
tgtIdx = len(output)
output[tgtIdx] = {}
output[tgtIdx]['handle'] = audioguide.tgt
output[tgtIdx]['weights'] = [str(0)]*8 # should BE LENGTH OF METRICS

############################################
## writing files for CATART visualization ##
############################################
# sf file
outputFile = open(OUTPUT_DIR+'/'+DATA_NAME+'.sf.txt', 'w')
for i in range(len(output)):
	h = output[i]['handle']
	outputFile.write( '"'+h.name+'" "'+h.filename+'" '+str(0)+" "+str(audioguide.trunc(h.endSec*1000, 2))+'\n')
outputFile.close()

# ud file
# idx, 0, 0, idx, 0, 0, 1, 0, samples, 0, ms, 0, idx, weights
outputFile = open(OUTPUT_DIR+'/'+DATA_NAME+'.ud.txt', 'w')
for i in range(len(output)):
	h = output[i]['handle']
	lengthSamp = int(h.endSec*audioguide.ops.SAMPLE_RATE)
	lengthMS = int(h.endSec*1000)
	writeList = [str(i), str(0), str(0), str(i), str(0), str(0), str(1), str(0), str(lengthSamp), str(0), str(lengthMS), str(0), str(i)]
	writeList.extend( output[i]['weights'] )
	print writeList
	for i in writeList: i = str(i)
	print writeList
	outputFile.write(' '.join(writeList)+'\n')
outputFile.close()


# sy file
outputFile = open(OUTPUT_DIR+'/'+DATA_NAME+'.sy.txt', 'w')
sfList = ''
for i in range(len(output)):
	h = output[i]['handle']
	sfList += ' "'+h.name+'"'
outputFile.write( '''Active , list " " ;
Loudness , list " " ;
Duration , list " " ;
StartTime , list " " ;
SoundFile , list''')
outputFile.write( sfList )
outputFile.write(  ''' ;
Energy , list " " ;
"AC1" , list " " ;
UnitID , list " " ;
HighFrequencyContent , list " " ;
MidFrequencyEnergy , list " " ;
HighFrequencyEnergy , list " " ;
SpectralCentroid , list " " ;
SpectralFlatness , list " " ;
Pitch , list " " ;
Shift , list " " ;
Periodicity , list " " ;
NoteNumber , list " " ;
Relstart , list " " ;
UnitType , list " " ;
RelID , list " " ;
WorkingSet , list " " ;
SampleSize , list " " ;
StartSample , list " " ;
SoundSet , list " " 0 ;
Label , list " " 0 ;''' )
outputFile.close()


# ds file
outputFile = open(OUTPUT_DIR+'/'+DATA_NAME+'.ds.txt', 'w')
outputFile.write('''UnitID 0 int 1 400 0 () ()
RelID 1 int 1 400 0 () ()
UnitType 2 symbol 1 5 1 () ()
SoundFile 3 symbol 1 1 0 () ()
SoundSet 4 symbol 1 1 0 () ()
WorkingSet 5 int 1 1 1 () ()
Active 6 bool 1 1 1 () ()
StartSample 7 int 1 99999 1 () ()
SampleSize 8 int 1 44100 1 () ()
StartTime 9 float 1 100000 0 () ()
Duration 10 float 1 1000 0 () ()
Relstart 11 float 1 1 0 () ()
Shift 12 int 1 32 1 () ()
''')
i = 13
for feature in metricsUsed:
	outputFile.write( feature+" "+str(i)+" float 1 100 0 () ()\n")
	i += 1
outputFile.close()


bestTgt.sort()
print bestTgt[0]
print bestTgt[1]
print bestTgt[2]
print bestTgt[-3]
print bestTgt[-2]
print bestTgt[-1]
