# first run this command:

#		`segmentSf.py examples/lachenmann.aiff -g 0.1 -o 2 -e -f examples/lachenmannGranular.txt'

# it will make a segmentation file called examples/lachenmannGranular.txt with LOTS of segments.  basically, it starts with an acoustic segmentation (meaning, it excludes silences), then it recusively divides up the acoustic segments into smaller and smaller durations until it reaches the grain size (-g, in this case 0.1 seconds) with a grain overlap of 2 (-o).  Thus there will be a lot more segments to choose from (in this case, 2248) compared to a purely acoustic segmentation (only 108).

###################################################
##   for more options, see the documentation at  ##
## http://crca.ucsd.edu/~ben/audioGuide/doc.html ##
###################################################

# set the target soundfile and its starttime and endtime values.
TARGET = ['cage.aiff', 0, 'end']

# set the target onset threshold sensitivity
TARGET_ONSET_THRESHOLD = -28

# set the corpus soundfile(s) which have first been segmented by running segmentSf.py
CORPUS = [{'name': 'lachenmann.aiff', 'segmentationFile': 'lachenmannGranular.txt'}]


# specify the timbral descriptors used for similarity calculation
#	note that "temporal descriptors" are included in the parameter package
DESCRIPTORS = {'mfccEnv': (1, 1)}

PARAMETER_PACKAGE = "granular"


