# musical writing example.  here, a small collection of piano samples are used as a corpus.  each file is labeled with a pitch (as the first 2 or 3 characters of the filename).  during concatenation, AudioGuide uses these pitches to write a list of commands for the BACH library in MAX/msp.  To see the score after you run this concatenation, open the max patch examples/musicalWriting.maxpat 


################  HEADER  ################
TARGET = ['cage.aiff', 0, "end"]
# specify the timbral descriptors used for similarity calculation
#	note that "temporal descriptors" are included in the parameter package
DESCRIPTORS = {'mfccEnv': (1), 'centroid-delta': (1, 1)}

# you can also use directory names to specify corpus entries.
# each soundfile in the directory will be used, as long as its extension is in the list SOUNDFILE_EXTENSIONS
CORPUS = [{'name': 'piano', 'MWinstrName': 'pianoPart'}]

################  OUTPUTS  ################
MAKE_BACH_SCORE = True

################ TARGET SEGMENTATION ################
TARGET_ONSET_THRESHOLD = -38

PARAMETER_PACKAGE = "segment2alignedChord"


################  CORPUS RESTRICTION   ################
# MW_DEFINE_INSTRUMENTS is where you define what staves will corrispod to which corpus entries.
# the order of instruments is the order they will appear in the bach score
# instruments are associated with corpus entries with the corpus parameter 'MWinstr', it must match item 1 of the tuple.  item 2 of the tuple is a dict with data about the clef/key/midi channnel.
# instruments are not included in the output score unless samples are actually chosen during cocatenation
MW_DEFINE_INSTRUMENTS = [('pianoPart', {'clef': 'FG'})] # you can also specify {'key': 'CM', 'midiChn': 1}

