#!/usr/bin/env python2.7
import sys, os
AG_PATH = os.path.dirname(os.path.realpath(__file__))#'/Users/ben/Documents/audioGuide/'
sys.path.append(AG_PATH)
import audioguide

'''
This script loops through all of the descriptors in audioguide and runs a
concatenation with the same target (cage) and corpus (lachenmann).  Only one
descriptor is used for each concatenation in order to compare the influence of 
different metrics.


'''

myTimeVaryingDescriptors = ['f0', 'slope', 'fluctuationstrength', 'inharmonicity', 'bandroughness', 'harmonicdecrease', 'perceptualoddtoevenratio', 'noisedecrease', 'decrease', 'perceptualslope', 'noisecentroid', 'perceptualcentroid', 'harmonicoddevenratio', 'noisespread', 'kurtosis', 'perceptualdeviation', 'roughness', 'spread', 'centroid', 'harmonicspread', 'harmonicenergy', 'perceptualdecrease', 'noiseenergy', 'noisevariation', 'perceptualrolloff', 'noisiness', 'harmonicdeviation', 'noiseskewness', 'variation', 'energyenvelope', 'loudness', 'relativespecificloudness', 'perceptualvariation', 'bandfluctuationstrength', 'noisekurtosis', 'harmonicvariation', 'sharpness', 'harmonicrolloff', 'noiserolloff', 'harmonicslope', 'perceptualspread', 'zeroCross', 'perceptualskewness', 'harmonickurtosis', 'noiseslope', 'rolloff', 'harmonicskewness', 'perceptualkurtosis', 'harmoniccentroid', 'skewness']

myPackageDescriptors = ['mfccEnv', 'mfccFrq', 'peakfrqs', 'crests', 'flatnesses', 'perceptualtristimuluses', 'harmonictristimuluses', 'chromas']

mySingleNumberDescriptors = ['power-seg', 'peakTime-seg', 'percentageInFile-seg','meanPower-seg', 'temporalDecrease-seg', 'temporalIncrease-seg', 'temporalCentroid-seg', 'logAttackTime-seg']


for name, list in [('timevary', myTimeVaryingDescriptors), ('package', myPackageDescriptors), ('singlenumb', mySingleNumberDescriptors)]:
	for descript in list:
		ops = '''
TARGET = ['examples/cage.aiff', 0, 'end']
TARGET_ONSET_THRESHOLD = -34
CORPUS = ['examples/lachenmann.aiff']
DESCRIPTORS = {'%s': (1, 1)}
PARAMETER_PACKAGE = "segment2segment"
'''%(descript)
		main = audioguide.main(AG_PATH, 'defaults.py', pythonicUserOptions=ops, printName="multiple iterations")
		main.concatenate() # run concatenation
		main.render(outputFileName=os.path.join(AG_PATH, 'output', '%s-%s.aiff'%(name, descript))) # run csound rendering


